<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Tests\Unit\Services\Analyzators\Validators;

use Seka\Portal\Modul\Statistiky\Tests\TestCase;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\HodnotenieEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Services\Analyzators\Validators\LexicalKontrolaVyhodnotenie;

/**
 * Class LexicalKontrolaVyhodnotenieTest
 *
 * @package Seka\Portal\Modul\Statistiky\Tests\Unit\Services\Analyzators\Validators
 */
class LexicalKontrolaVyhodnotenieTest extends TestCase
{
    /**
     *
     */
    public function testValidateCorrectKontrolaVyhodnotenie()
    {
        $validator = new LexicalKontrolaVyhodnotenie();

        self::assertTrue($validator->validate(HodnotenieEmisnejKontrolyEnum::SPOSOBILE()->value));
    }

    /**
     *
     */
    public function testValidateIncorrectKontrolaVyhodnotenie()
    {
        $validator = new LexicalKontrolaVyhodnotenie();

        self::assertFalse($validator->validate('INCORRECT'));
    }

    /**
     *
     */
    public function testValidateEmptyKontrolaVyhodnotenie()
    {
        $validator = new LexicalKontrolaVyhodnotenie();

        self::assertFalse($validator->validate(''));
    }

    /**
     *
     */
    public function testGetErrorMsgWithError()
    {
        $incorrectKontrolaVyhodnotenie = 'INCORRECT';
        $validator = new LexicalKontrolaVyhodnotenie();
        $validator->validate($incorrectKontrolaVyhodnotenie);
        $message = sprintf('povolene hodnoty: %s, %s', implode(',', HodnotenieEmisnejKontrolyEnum::toValues()), $incorrectKontrolaVyhodnotenie);
        $actualMessage = $validator->getErrorMsg($incorrectKontrolaVyhodnotenie);

        self::assertEquals($message, $actualMessage);
        self::assertIsString($actualMessage);
    }
}
